Loading...
Searching...
No Matches
Opm::PiecewiseLinearTwoPhaseMaterialParams< TraitsT, VectorT > Class Template Reference

Specification of the material parameters for a two-phase material law which uses a table and piecewise constant interpolation. More...

`#include <PiecewiseLinearTwoPhaseMaterialParams.hpp>`

Inheritance diagram for Opm::PiecewiseLinearTwoPhaseMaterialParams< TraitsT, VectorT >:

## Public Types

using | ValueVector = VectorT
using | Traits = TraitsT

## Public Member Functions

| PiecewiseLinearTwoPhaseMaterialParams (ValueVector SwPcwnSamples, ValueVector pcwnSamples, ValueVector SwKrwSamples, ValueVector krwSamples, ValueVector SwKrnSamples, ValueVector krnSamples)
void | finalize ()
| Calculate all dependent quantities once the independent quantities of the parameter object have been set.
void | checkFinalized () const
| Check if the parameter object has been finalized.
OPM_HOST_DEVICE const ValueVector & | SwKrwSamples () const
| Return the wetting-phase saturation values of all sampling points.
OPM_HOST_DEVICE const ValueVector & | SwKrnSamples () const
| Return the wetting-phase saturation values of all sampling points.
OPM_HOST_DEVICE const ValueVector & | SwPcwnSamples () const
| Return the wetting-phase saturation values of all sampling points.
OPM_HOST_DEVICE const ValueVector & | pcwnSamples () const
| Return the sampling points for the capillary pressure curve.
template<class Container>
void | setPcnwSamples (const Container &SwValues, const Container &values)
| Set the sampling points for the capillary pressure curve.
OPM_HOST_DEVICE const ValueVector & | krwSamples () const
| Return the sampling points for the relative permeability curve of the wetting phase.
template<class Container>
void | setKrwSamples (const Container &SwValues, const Container &values)
| Set the sampling points for the relative permeability curve of the wetting phase.
OPM_HOST_DEVICE const ValueVector & | krnSamples () const
| Return the sampling points for the relative permeability curve of the non-wetting phase.
template<class Container>
void | setKrnSamples (const Container &SwValues, const Container &values)
| Set the sampling points for the relative permeability curve of the non-wetting phase.
Public Member Functions inherited from Opm::EnsureFinalized
OPM_HOST_DEVICE void | finalize ()
| Mark the object as finalized.

## Friends

template<class ViewType, class Traits, class Container>
PiecewiseLinearTwoPhaseMaterialParams< Traits, ViewType > | Opm::gpuistl::make_view (PiecewiseLinearTwoPhaseMaterialParams< Traits, Container > &params)

## Additional Inherited Members

Protected Member Functions inherited from Opm::EnsureFinalized
OPM_HOST_DEVICE | EnsureFinalized ()
| The default constructor.
OPM_HOST_DEVICE void | check () const

## Detailed Description

template<class TraitsT, class VectorT = std::vector<typename TraitsT::Scalar>>
class Opm::PiecewiseLinearTwoPhaseMaterialParams< TraitsT, VectorT >

Specification of the material parameters for a two-phase material law which uses a table and piecewise constant interpolation.

## Member Function Documentation

## krnSamples()

template<class TraitsT, class VectorT = std::vector<typename TraitsT::Scalar>>

OPM_HOST_DEVICE const ValueVector & Opm::PiecewiseLinearTwoPhaseMaterialParams< TraitsT, VectorT >::krnSamples | ( |  | ) | const

inline

Return the sampling points for the relative permeability curve of the non-wetting phase.

This curve is assumed to depend on the wetting phase saturation

## krwSamples()

template<class TraitsT, class VectorT = std::vector<typename TraitsT::Scalar>>

OPM_HOST_DEVICE const ValueVector & Opm::PiecewiseLinearTwoPhaseMaterialParams< TraitsT, VectorT >::krwSamples | ( |  | ) | const

inline

Return the sampling points for the relative permeability curve of the wetting phase.

This curve is assumed to depend on the wetting phase saturation

## pcwnSamples()

template<class TraitsT, class VectorT = std::vector<typename TraitsT::Scalar>>

OPM_HOST_DEVICE const ValueVector & Opm::PiecewiseLinearTwoPhaseMaterialParams< TraitsT, VectorT >::pcwnSamples | ( |  | ) | const

inline

Return the sampling points for the capillary pressure curve.

This curve is assumed to depend on the wetting phase saturation

## setKrnSamples()

template<class TraitsT, class VectorT = std::vector<typename TraitsT::Scalar>>
template<class Container>

void Opm::PiecewiseLinearTwoPhaseMaterialParams< TraitsT, VectorT >::setKrnSamples | ( | const Container & | SwValues,
|  | const Container & | values )

inline

Set the sampling points for the relative permeability curve of the non-wetting phase.

This curve is assumed to depend on the wetting phase saturation

## setKrwSamples()

template<class TraitsT, class VectorT = std::vector<typename TraitsT::Scalar>>
template<class Container>

void Opm::PiecewiseLinearTwoPhaseMaterialParams< TraitsT, VectorT >::setKrwSamples | ( | const Container & | SwValues,
|  | const Container & | values )

inline

Set the sampling points for the relative permeability curve of the wetting phase.

This curve is assumed to depend on the wetting phase saturation

## setPcnwSamples()

template<class TraitsT, class VectorT = std::vector<typename TraitsT::Scalar>>
template<class Container>

void Opm::PiecewiseLinearTwoPhaseMaterialParams< TraitsT, VectorT >::setPcnwSamples | ( | const Container & | SwValues,
|  | const Container & | values )

inline

Set the sampling points for the capillary pressure curve.

This curve is assumed to depend on the wetting phase saturation

The documentation for this class was generated from the following file:

- opm/material/fluidmatrixinteractions/PiecewiseLinearTwoPhaseMaterialParams.hpp